/* Copyright 2022 Sensaru GmbH */

#ifndef LIBC1_NET_SRC_EXCEPTIONS_H_
#define LIBC1_NET_SRC_EXCEPTIONS_H_

#include <stdexcept>

namespace C1Net {

class Exception : public std::runtime_error {
 public:
  explicit Exception(const std::string &message) : runtime_error(message) {}
};

class TimeoutException : public Exception {
 public:
  explicit TimeoutException(const std::string &message) : Exception(message) {}
};

class ClosedException : public Exception {
 public:
  explicit ClosedException(const std::string &message) : Exception(message) {}
};

class AddressInUseException : public Exception {
 public:
  explicit AddressInUseException(const std::string &message) : Exception(message) {}
};

class ClientHandshakeFailedException : public Exception {
 public:
  explicit ClientHandshakeFailedException(const std::string &message) : Exception(message) {}
};

}

#endif //LIBC1_NET_SRC_EXCEPTIONS_H_
