/* Copyright 2022 Sensaru GmbH */

#ifndef LIBC1_NET_SRC_HEX_H_
#define LIBC1_NET_SRC_HEX_H_

#include <string>
#include <array>
#include <cstdint>

namespace C1Net {

class Hex {
 public:
  Hex() = delete;

  /**
   * Converts a byte array to a hex string.
   *
   * @param buffer The byte array to convert.
   * @param size The size of the buffer.
   * @return Returns the hex string of the byte array.
   */
  static std::string GetHex(const char *buffer, uint32_t size);
 private:
  static constexpr std::array<char, 16> kBinaryToAsciiTable{0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46};
};

}

#endif //LIBC1_NET_SRC_HEX_H_
