/* Copyright 2022 Sensaru GmbH */

#ifndef LIBC1_NET_SRC_TCPCOMMON_H_
#define LIBC1_NET_SRC_TCPCOMMON_H_

#include "Exceptions.h"

#include <vector>
#include <cstdint>
#include <string>
#include <memory>

#include <gnutls/gnutls.h>

namespace C1Net {

typedef std::vector<uint8_t> TcpPacket;

class CertificateCredentials {
 public:
  explicit CertificateCredentials(gnutls_certificate_credentials_t credentials);
  ~CertificateCredentials();
  gnutls_certificate_credentials_t Get();
 private:
  gnutls_certificate_credentials_t credentials_ = nullptr;
};

struct CertificateInfo {
  std::string cert_file;
  std::string cert_data;
  std::string key_file;
  std::string key_data;
  std::string ca_file;
  std::string ca_data;
};
typedef std::shared_ptr<CertificateInfo> PCertificateInfo;

}

#endif //LIBC1_NET_SRC_TCPCOMMON_H_
